//Please use the Customizer to interact with this (if necessary, show it by clearing the checkbox in front of View | Hide Customizer), and close this Editor window.

/* [Overview] */
//Part
PARTNO = "0"; // [0:All, 1:Front, 2:Back, 3:Left Side, 4:Right Side, 5:Top, 6:Bottom,7:Dividers]

//Type of Lid
LidType = "0"; // [0:None, 1:Sliding, 2:Rabbeted, 3:Hinged, 4:Pinned]

//Number of pins (must be odd if using a pinned lid)
pins=13;

maxlocation = pins-1;

//Height of box bottom (expressed as a percentage if using a hinged or rabbeted lid)
boxbottomheight=50; // [0:100]

//Endmill Diameter
diameter=0.125;

//Part Spacing
partspacing=2;

//Units
Units="0"; // [0:Inches, 1:Millimeters]

/* [Size] */
//Length
length = 3;

//Width
width = 6;

//Height
height = 4;

//Thickness
thickness = 0.375;

//Lid and Bottom Thickness
bottomlidthickness=0.125;

/* [Dividers] */
//Number of Dividers
Dividers = 0;

//Orientation of Dividers
DividerOrientation = "0"; // [0:widthwise, 1:lengthwise]

//Height of Dividers (percentage of interior height)
DividerHeight = 50; //[0:100]

location = ceil(boxbottomheight/100*(maxlocation-2))+2;

conversionfactor = (Units=="0") ? 25.4 : 1;

cwidth = width*conversionfactor;
clength = length*conversionfactor;
cheight = height*conversionfactor;
cthickness = thickness*conversionfactor;
cbottomlidthickness=bottomlidthickness*conversionfactor;
cpartspacing=partspacing*conversionfactor;

cdiameter = diameter*conversionfactor;

cinteriorwidth = cwidth-cthickness*2;
cinteriorlength = clength-cthickness*2;

cinteriorheight=cheight-cbottomlidthickness*2-cthickness;

cdivheight=cinteriorheight*DividerHeight/100;

cpins=pins;
cpinsize=cheight/pins;
chalfpin=cpinsize/2;
cpinspacing=cpinsize*2;

//Front
module Front() {
rheight = cheight-cbottomlidthickness*2;
rsheight = (LidType=="1") ? rheight : cheight;
   
difference() {
    cube(size = [cwidth,cthickness,rsheight], center = false);
translate([cthickness-cbottomlidthickness, cthickness-cbottomlidthickness, cbottomlidthickness]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);
};
translate([thickness+cbottomlidthickness*2, cthickness-cbottomlidthickness, cheight-cbottomlidthickness*2]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);
};
if (Dividers == 0) {} else {if (DividerOrientation == "1") {translate([cthickness,0,0]) {for ( i = [0 : Dividers-1] ){translate([(cinteriorwidth/(Dividers+1))*i+cinteriorwidth/(Dividers+1)-cbottomlidthickness/2,cbottomlidthickness*1.5,cbottomlidthickness*2]) cube(size = [cbottomlidthickness,cbottomlidthickness*2,cdivheight]);};};};};
if (LidType == "2") {translate([-cthickness/2, cthickness/2, cpinsize*location-cdiameter]){cube(size = [cwidth+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "2") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cdiameter*2]){cube(size = [cwidth+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "3") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cpinsize/2-cdiameter/2]){cube(size = [cwidth+cthickness,cthickness*2,cdiameter], center = false);
    };};
if (LidType == "4") {translate([-cthickness/2, -cthickness/2, cpinsize*(pins-1)]){cube(size = [cwidth+cthickness,cthickness*2,cthickness*2], center = false);
    };};
for ( i = [0 : cpins/2] ){
    translate([0, 0, cpinspacing*i])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
};
for ( i = [0 : cpins/2] ){
    translate([cwidth-cthickness, 0, cpinspacing*i])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
    };
};
};


//Bottom
module Bottom() {translate([cthickness-cbottomlidthickness, cthickness-cbottomlidthickness, cbottomlidthickness-cpartspacing]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,clength-cthickness*2+cbottomlidthickness*2,cbottomlidthickness], center = false);
};
};

//Top
module Top() {
//lid length
lidlength = clength-cthickness*2+cbottomlidthickness*2;
clidlength = clength-cthickness*0.5;
slidlength = clength-cthickness+cbottomlidthickness*2;
rlidwith = (LidType=="1") ? slidlength : lidlength;

lidpos = cthickness-cbottomlidthickness;
llidpos = 0;
rlidpos = (LidType=="1") ? llidpos : lidpos;

if (LidType == "4") {translate([cthickness, 0, cheight-cpinsize+cpartspacing]) {difference(){union () {
    cube(size = [cwidth-cthickness*2,clidlength,cpinsize], center = false);
    translate ([0,clidlength,cpinsize/2]) {cube(size = [cwidth-cthickness*2,cpinsize/2,cpinsize/2], center = false);
    };
    translate ([0,clidlength,cpinsize/2]) rotate([0,90,0]){cylinder($fn = 50, $fa = 120, $fs = 96, h = cwidth-cthickness*2, r1 = cpinsize/2, r2 = cpinsize/2, center = false);
    };};
    translate([-cpinsize/2, clength-cpinsize/2-cdiameter/2, cpinsize/2]) {rotate([0,90,0])cylinder($fn = 50, $fa = 120, $fs = 96, h = cthickness, r1 = cdiameter/2, r2 = cdiameter/2, center = false);}
    translate([cwidth-cpinsize*3, clength-cpinsize/2-cdiameter/2, cpinsize/2]) {rotate([0,90,0])cylinder($fn = 50, $fa = 120, $fs = 96, h = cthickness, r1 = cdiameter/2, r2 = cdiameter/2, center = false);}
    ;};};
    } else if (LidType == "0") {} else {{translate([cthickness-cbottomlidthickness, rlidpos, cheight-cbottomlidthickness*2+cpartspacing]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,rlidwith,cbottomlidthickness], center = false);
    };
};
};
};

//Back
module Back() {
translate([0, clength-cthickness+cpartspacing, 0]) {
    difference() {
    cube(size = [cwidth,cthickness,cheight], center = false);
translate([cthickness-cbottomlidthickness, -cbottomlidthickness, cbottomlidthickness]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);
};
translate([cthickness-cbottomlidthickness, -cbottomlidthickness, cheight-cbottomlidthickness*2]) {
    cube(size = [cwidth-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);
};
if (Dividers == 0) {} else {if (DividerOrientation == "1") {translate([cthickness,0,0]) {for ( i = [0 : Dividers-1] ){translate([(cinteriorwidth/(Dividers+1))*i+cinteriorwidth/(Dividers+1)-cbottomlidthickness/2,-cbottomlidthickness,cbottomlidthickness*2]) cube(size = [cbottomlidthickness,cbottomlidthickness*2,cdivheight]);};};};};
if (LidType == "2") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cdiameter]){cube(size = [cwidth+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "2") {translate([-cthickness/2, cthickness/2, cpinsize*location-cdiameter*2]){cube(size = [cwidth+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "3") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cpinsize/2-cdiameter/2]){cube(size = [cwidth+cthickness,cthickness*2,cdiameter], center = false);
    };};
if (LidType == "4") {translate([-cthickness/2, -cthickness/2, cpinsize*(pins-1)]){cube(size = [cwidth+cthickness,cthickness*2,cthickness*2], center = false);
    };};
for ( i = [0 : cpins/2] ){
    translate([0, 0, cpinspacing*i])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
};
for ( i = [0 : cpins/2] ){
    translate([cwidth-cthickness, 0, cpinspacing*i])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
    };
};
};
};

//rabbet for lid
rabbetwidth = clength-cthickness*2+cbottomlidthickness*2;
rrabbetwidth = (LidType=="1") ? clength : rabbetwidth;
    
rabbetpos = cthickness-cbottomlidthickness;
lrabbetpos = -cbottomlidthickness;
rrabbetpos = (LidType=="1") ? lrabbetpos : rabbetpos;
  
//Left side
module LeftSide() {
translate([cthickness-cpartspacing, 0, 0]) {
    rotate([0, 0, 90]) {
difference() {
    cube(size = [clength,cthickness,cheight], center = false);
 translate([cthickness-cbottomlidthickness, -cbottomlidthickness, cbottomlidthickness]) {
    cube(size = [clength-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);};
if (Dividers == 0) {} else {if (DividerOrientation == "0") {translate([cthickness,0,0]) {for ( i = [0 : Dividers-1] ){translate([(cinteriorlength/(Dividers+1))*i+cinteriorlength/(Dividers+1)-cbottomlidthickness/2,-cbottomlidthickness,cbottomlidthickness*2]) cube(size = [cbottomlidthickness,cbottomlidthickness*2,cdivheight]);};};};};
if (LidType == "4") { translate([clength-cthickness/2, cthickness*0.5, cpinsize*pins-cpinsize/2]) {rotate([90,0,0])cylinder($fn = 50, $fa = 120, $fs = 96, h = cthickness, r1 = cdiameter/2, r2 = cdiameter/2, center = false);};} else { translate([rrabbetpos, -cbottomlidthickness, cheight-cbottomlidthickness*2]) {
    cube(size = [rrabbetwidth,cbottomlidthickness*2,cbottomlidthickness], center = false);
};};
if (LidType == "2") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cdiameter]){cube(size = [clength+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "2") {translate([-cthickness/2, cthickness/2, cpinsize*location-cdiameter*2]){cube(size = [clength+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "3") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cpinsize/2-cdiameter/2]){cube(size = [clength+cthickness,cthickness*2,cdiameter], center = false);
    };};
for ( i = [0 : cpins/2] ){
    translate([0, 0, cpinspacing*i-cpinsize])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
};
for ( i = [0 : cpins/2] ){
    translate([clength-cthickness, 0, cpinspacing*i-cpinsize])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
    };
};
};
};
};

//Right Side
module RightSide() {
translate([cwidth+cpartspacing, 0, 0]) {
    rotate([0, 0, 90]) {
difference() {
    cube(size = [clength,cthickness,cheight], center = false);
  translate([cthickness-cbottomlidthickness, cthickness-cbottomlidthickness, cbottomlidthickness]) {
    cube(size = [clength-cthickness*2+cbottomlidthickness*2,cbottomlidthickness*2,cbottomlidthickness], center = false);
};
if (Dividers == 0) {} else {if (DividerOrientation == "0") {translate([cthickness,0,0]) {for ( i = [0 : Dividers-1] ){translate([(cinteriorlength/(Dividers+1))*i+cinteriorlength/(Dividers+1)-cbottomlidthickness/2,cbottomlidthickness*1.5,cbottomlidthickness*2]) cube(size = [cbottomlidthickness,cbottomlidthickness*2,cdivheight]);};};};}; 
if (LidType == "4") { translate([clength-cthickness/2, cthickness*1.5, cpinsize*pins-cpinsize/2]) {rotate([90,0,0])cylinder($fn = 50, $fa = 120, $fs = 96, h = cthickness, r1 = cdiameter/2, r2 = cdiameter/2, center = false);};} else { translate([rrabbetpos, cthickness-cbottomlidthickness, cheight-cbottomlidthickness*2]) {
    cube(size = [rrabbetwidth,cbottomlidthickness*2,cbottomlidthickness], center = false);
};};
if (LidType == "2") {translate([-cthickness/2, cthickness/2, cpinsize*location-cdiameter]){cube(size = [clength+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "2") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cdiameter*2]){cube(size = [clength+cthickness,cthickness,cdiameter], center = false);
    };};
if (LidType == "3") {translate([-cthickness/2, -cthickness/2, cpinsize*location-cpinsize/2-cdiameter/2]){cube(size = [clength+cthickness,cthickness*2,cdiameter], center = false);
    };};
for ( i = [0 : cpins/2] ){
    translate([0, 0, cpinspacing*i-cpinsize])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
};
for ( i = [0 : cpins/2] ){
    translate([clength-cthickness, 0, cpinspacing*i-cpinsize])
    cube(size = [cthickness,cthickness,cpinsize], center = false);
    };
};
};
};
};

//Dividers
module Dividers() {if (Dividers == 0) {} else {if (DividerOrientation == "0"){translate([0,cthickness,0]) {for ( i = [0 : Dividers-1] ){translate([cthickness,(cinteriorlength/(Dividers+1))*i+cinteriorlength/(Dividers+1)-cbottomlidthickness/2,cbottomlidthickness*2]) cube(size = [cinteriorwidth+cbottomlidthickness*2,cbottomlidthickness,cdivheight]);};};} else {translate([cthickness,0,0]) {for ( i = [0 : Dividers-1] ){translate([(cinteriorwidth/(Dividers+1))*i+cinteriorwidth/(Dividers+1)-cbottomlidthickness/2,cthickness+cpartspacing/2,cbottomlidthickness*2]) cube(size = [cbottomlidthickness,cinteriorlength+cbottomlidthickness*2,cdivheight]);};};};};};


// [0:All, 1:Front, 2:Back, 3:Left Side, 4:Right Side, 5:Top, 6:Bottom

 if (PARTNO == "1") Front();
 if (PARTNO == "2") Back();
 if (PARTNO == "3") LeftSide();
 if (PARTNO == "4") RightSide();
 if (PARTNO == "5") Top();
 if (PARTNO == "6") Bottom();
 if (PARTNO == "7") Dividers();
       
  // optionally use 0 for whole object
 if (PARTNO == "0") {
   Front();
   Back();
   LeftSide();
   RightSide();
   Top();
   Bottom();
   Dividers();
 }